#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <time.h>

#include "bst.h"

#define MAX_NUMS 10

bool le(void *a, void * b)
   {
   return *((int *) a) <= *((int *) b);
   }

bool eq(void *a, void * b)
   {
   return *((int *) a) == *((int *) b);
   }

void print(void * d)
   {
   printf("%d\n", *((int *) d) );
   }

void free_data(void * d)
   {
   free(d);
   }

int main(int argc, char ** argv)
   {
   struct bst * bst = bst_new(le, eq);
   if (NULL == bst)
      {
      perror("bst_new");
      exit(EXIT_FAILURE);
      }

   ////////////////////////////////////////
   printf ("======================\nGenerating\n");
   //srand(time());
   int * ip;
   for (int i = 0 ; i < MAX_NUMS ; ++i)
      {
      ip = malloc(sizeof(int));
      if (NULL == ip)
	 {
	 perror("malloc");
	 exit(EXIT_FAILURE);
	 }

      *ip = rand();
      printf("%d\n", *ip);
      if (NULL == bst_insert(bst, ip))
	 {
	 perror("bst_insert");
	 exit(EXIT_FAILURE);
	 }
      }
   printf ("======================\n");


   ////////////////////////////////////////
   bst_walk_inorder(bst, print);

   ////////////////////////////////////////
   int i = 1;
   int * p = (int *) bst_search(bst, &i);
   if (NULL == p)
      printf("%d NOT FOUND\n", i);
   else
      printf("%d FOUND\n", i);

   i = *ip;
   p = (int *) bst_search(bst, &i);
   if (NULL == p)
      printf("%d NOT FOUND\n", i);
   else
      printf("%d FOUND\n", i);

   i = *ip;
   p = (int *) bst_search_iterative(bst, &i);
   if (NULL == p)
      printf("%d NOT FOUND\n", i);
   else
      printf("%d FOUND\n", i);


   int * min = bst_minimum(bst);
   if (NULL == min)
      printf("tree has no minimum.  empty?\n");
   else
      printf("%d MINIMUM\n", *min);

   int * max = bst_maximum(bst);
   if (NULL == max)
      printf("tree has no maximum.  empty?\n");
   else
      printf("%d MAXIMUM\n", *max);

   ////////////////////////////////////////
   printf("\n\nWalking inorder with iterators\n");
   struct bst_iterator * it = bst_begin(bst);
   if (NULL == it)
      {
      perror("bst_begin");
      exit(EXIT_FAILURE);
      }
   do
      printf("%d\n", *((int *) bst_value(it)));
   while (bst_next(it));
   free(it);


   ////////////////////////////////////////
   printf("\n\nWalking reverse inorder with iterators\n");
   it = bst_end(bst);
   if (NULL == it)
      {
      perror("bst_end");
      exit(EXIT_FAILURE);
      }
   do
      printf("%d\n", *((int *) bst_value(it)));
   while (bst_prev(it));
   free(it);


   bst_walk_inorder(bst, free_data);
   bst_delete(bst);

   exit(EXIT_SUCCESS);
   }
